# ===============================================================
# TestFloatingPointOutput.py: Demo floating point output ...
# ===============================================================

# main method ...

def main():
    print("--- Enter TestFloatingPointOutput.main()     ... ");
    print("--- ======================================== ... ");

    # Define approximate value of pi ....

    a = 3.1415926;

    # Demo floating point formats ...

    print("--- Demo floating point formats ...");

    print("{:.2f}".format(a));
    print("{:.4f}".format(a));

    # Demo exponential formats ...

    print("--- Demo exponential formats ...");

    print("{:.2e}".format(a));
    print("{:.4e}".format(a));

    # Use precision variable ...

    print("--- ");
    print("--- Use of precision variable ...");
    print("--- ");

    precision = 5
    print( "{:.{}f}".format( a, precision ) );

    # Demo older % formatter (i.e., same as printf() in C and Java)

    print("--- Demo older % formatter ...");
    print("--- pi = %1.2f " % a);
    print("--- pi = %1.4f " % a);

    # Format array of numbers ...
    
    print("--- ");
    print("--- Format array of numbers in exponential format ...");
    print("--- ");

    numbers = [34.23, -0.123334987, 1, 24.223, 3449685.1];

    for x in numbers:
       print ("--- {:14.6e}".format(x));

    print("--- ");
    print("--- Print array of comma-separated numbers ...");
    print("--- ");

    for x in numbers:
       print ("--- {:14,.3f}".format(x));

    # Demo conversion of basis ...

    print("--- ");
    print("--- Demo conversion of basis ...");
    print("--- ");

    b = 21;

    print("--- ");
    print("--- Print 21 in decimal, hexidecimal, octal and binary formats ...");
    print("--- {0:d} - {0:x} - {0:o} - {0:b} ".format(b))

    # Multiple substitution values ...

    print("--- ");
    print("--- Demo multiple substitutions ...");
    print("--- ");

    s1 = "cats"
    s2 = "dogs"
    s3 = "%s and %s living together" % (s1, s2)
    s4 = "{} and {} living together ".format(s1, s2)

    print("--- %s " % s3);
    print("--- %s " % s4);

    # ===================================================
    # Formatting table data ...
    # ===================================================

    print("--- ");
    print("--- Formatting table data ...");
    print("--- ===================================== ...");

    # data

    starters = [
        [ 'Andre Iguodala', 4, 3,  7 ],
        [  'Klay Thompson', 5, 0, 21 ],
        [  'Stephen Curry', 5, 8, 36 ],
        [  'Draymon Green', 9, 4, 11 ],
        [   'Andrew Bogut', 3, 0,  2 ],
    ]

    # define format row

    row = "| {player:<16s} | {reb:2d} | {ast:2d} | {pts:2d} |".format

    for p in starters:
        print(row(player=p[0], reb=p[1], ast=p[2], pts=p[3]))

    print("--- ======================================== ... ");
    print("--- Leave TestFloatingPointOutput.main()     ... ");

# call the main method ...

main()
