# =========================================================
# Program for demonstration of one hot encoding with Pandas
# =========================================================

# Import libraries

import numpy as np
import pandas as pd

print("--- Demonstrate onehot encoding with Pandas ...")
print("--- ======================================= ...")

# Import employee data ...

print("--- PART 1: Import and print employee.csv ...")
print("--- ======================================= ...")

data01 = pd.read_csv("../data/employee.csv")

print( data01.shape)
print( data01.head())
print( data01.info())
print( data01.dtypes )

print("--- Column of employee gender ...")

print ( data01["Gender"] )

print("--- Column of employee remarks ...")

print ( data01["Remarks"] )

print("--- Onehot encoding for remarks and gender columns  ...")

encoded_data = pd.get_dummies( data01, columns = ['Remarks', 'Gender'])
print(encoded_data)

# Import titanic data ...

print("--- PART 2: Import and print titanic.csv    ...")
print("--- ======================================= ...")

data02 = pd.read_csv("../data/titanic.csv")

print( data02.shape )
print( data02.head(25))

print("--- Onehot encoding for fare column (explodes dimensionality -- doesn't look useful) ...")

encoded_data = pd.get_dummies( data02, columns = ['Fare'])
print(encoded_data)

# Import stock data ...

print("--- PART 3: Import and print stocks.csv    ...")
print("--- ======================================= ...")

data03 = pd.read_csv("../data/stocks.csv")
print( data03.shape )
print( data03.head(25))

print("--- Onehot encoding for stock symbol ...")

encoded_data = pd.get_dummies( data03, columns = ['symbol'])
print(encoded_data)

print("--- ======================================= ...")
print("--- Finished !! ...")

