# =======================================================================
# TestDateType.py: Exercise basic date and time types.
# =======================================================================

import datetime

from datetime import date
from datetime import time

# main method ...

def main():
    print("--- Enter TestDateTime.main()                ... ");
    print("--- ======================================== ... ");

    print("--- ");
    print("--- Part 1: Get current date and time ... ");
    print("--- ");

    current_date = datetime.date.today();
    print("--- current date = {:s} ... ".format( str(current_date)) ); 

    current_time = datetime.datetime.now();
    print("--- current time = {:s} ... ".format( str(current_time)) ); # <-- Format datetime output.

    print("--- ");
    print("--- Part 2: Examine contents of datetime ... ");
    print("--- ");

    print( dir(datetime) );

    print("--- ");
    print("--- Part 3: Create datetime and date objects ...");
    print("--- ");

    date01 = datetime.date(2022, 12, 3);
    print("--- date01 = {:s} ... ".format( str(date01)) );

    date02 = date(2022, 12, 3);
    print("--- date02 = {:s} ... ".format( str(date02)) );

    print("--- ");
    print("--- Part 4: Extract day, month and year from date ...");
    print("--- ");

    print("--- date01.year  = {:s} ... ".format( str(date01.year) ) );
    print("--- date01.month = {:s} ... ".format( str(date01.month) ) );
    print("--- date01.day   = {:s} ... ".format( str(date01.day) ) );

    print("--- ");
    print("--- Part 5: Represent time with a time object ...");
    print("--- ");

    time01 = time();                # time01: hour =  0, minute = 0, second =  0.
    time02 = time(12,2,15);         # time02: hour = 12, minute = 2, second = 15.
    time03 = time( hour = 12, minute = 2, second = 30); 

    print("--- time01 = {:s} ... ".format( str( time01 ) ) );
    print("--- time02 = {:s} ... ".format( str( time02 ) ) );
    print("--- time03 = {:s} ... ".format( str( time03 ) ) );

    print("--- ");
    print("--- Part 6: Extract hour, minute and second from time ...");
    print("--- ");

    print("--- time03.hour   = {:s} ... ".format( str(time03.hour) ) );
    print("--- time03.minute = {:s} ... ".format( str(time03.minute) ) );
    print("--- time03.second = {:s} ... ".format( str(time03.second) ) );

    print("--- ");
    print("--- Part 7: Create datetime object ...");
    print("--- ");

    datetime01 = datetime.datetime( 2022,12, 3, 13, 14, 15 );
    print("--- datetime01 = {:s} ... ".format( str( datetime01 ) ) );

    print("--- ");
    print("--- Part 8: String to datetime object ...");
    print("--- ");

    date_string = "21 December, 2022"
    print("--- date_string =", date_string)
    print("--- type of date_string =", type(date_string))

    date_object = datetime.datetime.strptime(date_string, "%d %B, %Y")
    print("--- date_object =", date_object)
    print("--- type of date_object =", type(date_object))

    print("--- ");
    print("--- Part 9: Format date using strftime ...");
    print("--- ");

    # mm/dd/YY H:M:S format

    s1 = datetime01.strftime("%m/%d/%Y, %H:%M:%S")
    print("--- datetime01 = {:s} ... ".format( s1 ) );

    # dd/mm/YY H:M:S format

    s2 = datetime01.strftime("%d/%m/%Y, %H:%M:%S")
    print("--- datetime01 = {:s} ... ".format( s2 ) );

    # custom format for date string ...

    date_string = "23 December, 2022"
    print("--- date_string = {:s} ... ".format( date_string ) );
    print("--- date_string (default)   =", date_string)

    datetime02 = datetime.datetime.strptime(date_string, "%d %B, %Y")
    print("--- datetime02 = {:s} ... ".format( str (datetime02) ));

    print("--- datetime02.year  = {:s} ... ".format( str(datetime02.year) ) );
    print("--- datetime02.month = {:s} ... ".format( str(datetime02.month) ) );
    print("--- datetime02.day   = {:s} ... ".format( str(datetime02.day) ) );
    
    print("--- ======================================== ... ");
    print("--- Leave TestDateTime.main()                ... ");

# call the main method ...

main()
