# ========================================================================
# TestAirPassengers01.py: Time series model of Air Passengers.
# ========================================================================

import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns 

# main method ...

def main():
    print("--- Enter TestAirPassengers01.main()         ... ");
    print("--- ======================================== ... ");

    print("--- ");
    print("--- Part 1: Read air passenger data ... ");
    print("--- ");

    df = pd.read_csv('../data/AirPassengers.csv')

    print( df )

    print("--- ");
    print("--- Part 2: Convert 'Month' column into datetime object ... ");
    print("---       : df['Month'] = pd.to_datetime(df['Month'], format='%Y-%m') ... ");
    print("--- ");

    df['Month'] = pd.to_datetime(df['Month'], format='%Y-%m')

    print(df.head())

    print("--- ");
    print("--- Part 3: Convert 'Month' column to an index ... ");
    print("--- ");

    df.index = df['Month']
    del df['Month']

    print(df.head())

    print("--- ");
    print("--- Part 4: Create simple line plot ... ");
    print("--- ");

    plt.plot(df, color="blue",label="Original Passenger Data")
    plt.ylabel("No of Passengers")
    plt.show()

    print("--- ======================================== ... ");
    print("--- Leave TestAirPassengers01.main()         ... ");

# call the main method ...

main()
